#include <iostream>
#define MAX 101
using namespace std;

typedef struct
{
	bool E[4];//0 up 1 down 2 left 3 right
	bool R[4];
	bool vis;
	int belong;
}gird;

int N,M,cnt,P,Ans;
int dx[4]={-1,1,0,0},dy[4]={0,0,-1,1};
gird G[MAX][MAX];

inline bool inrange(int x,int y)
{
	return x>=1 && x<=N && y>=1 && y<=M;
}

void init()
{
	int i,j,k,C,x,y;
	freopen("arcane.in","r",stdin);
	freopen("arcane.out","w",stdout);
	cin >> N >> M;
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=M;j++)
		{
			scanf("%d",&C);
			for (k=0;k<4;k++)
			{
				G[i][j].E[k]=(C >> (3-k)) & 1;
			}
		}
	}
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=M;j++)
		{
			for (k=0;k<4;k++)
			{
				if (G[i][j].E[k])
				{
					x=i+dx[k];
					y=j+dy[k];
					if (inrange(x,y))
					{
						if (k==0)
							G[x][y].R[1]=true;
						else if (k==1)
							G[x][y].R[0]=true;
						else if (k==2)
							G[x][y].R[3]=true;
						else if (k==3)
							G[x][y].R[2]=true;
					}
				}
			}
		}
	}
}

void dfs(int i,int j)
{
	G[i][j].vis=true;
	int k,x,y;
	for (k=0;k<4;k++)
	{
		if (!G[i][j].E[k]) continue;
		x=i+dx[k];
		y=j+dy[k];
		if (inrange(x,y) && !G[x][y].vis)
		{
			dfs(x,y);
		}
	}
}

void rdfs(int i,int j)
{
	G[i][j].belong=P;
	int k,x,y;
	for (k=0;k<4;k++)
	{
		if (!G[i][j].R[k]) continue;
		x=i+dx[k];
		y=j+dy[k];
		if (inrange(x,y) && G[x][y].vis && !G[x][y].belong)
		{
			cnt++;
			rdfs(x,y);
		}
	}
}

void clear()
{
	int i,j;
	for (i=1;i<=N;i++)
		for (j=1;j<=M;j++)
			G[i][j].vis=false;
}

void kosaraju()
{
	int i,j;
	for (i=1;i<=N;i++)
	{
		for (j=1;j<=M;j++)
		{
			if (!G[i][j].belong)
			{
				P++;
				cnt=1;
				dfs(i,j);
				rdfs(i,j);
				if (cnt!=1)
					Ans++;
				clear();
			}
		}
	}
}

int main()
{
	init();
	kosaraju();
	cout << Ans << endl;
	return 0;
}